/**
 *    @file cal.h
 *
 *    Defines function prototypes for using CAL.
 *    <p>
 *    Copyright (C) 2004-2008 Nokia. All rights reserved.
 *
 *    @author Juha Yrjl <juha.yrjola@nokia.com>
 *    @author Semi Malinen <semi.malinen@nokia.com>
 */

#ifndef CAL_H
#define CAL_H

#define CAL_MAX_NAME_LEN	16
#define CAL_FLAG_USER		0x0001
#define CAL_FLAG_WRITE_ONCE	0x0002

#ifdef __cplusplus
extern "C" {
#endif

struct cal;

extern void (* cal_debug_log)(int level, const char *str);
extern void (* cal_error_log)(const char *str);

int  cal_init(struct cal** cal_out);
void cal_finish(struct cal* cal);

int  cal_read_block(struct cal*    cal,
                    const char*    name,
                    void**         ptr,
                    unsigned long* len,
                    unsigned long  flags);
int  cal_write_block(struct cal*   cal,
                     const char*   name,
                     const void*   data,
                     unsigned long data_len,
                     unsigned long flags);

int  cal_lock_otp_area(struct cal* cal, unsigned int flag);

#ifdef __cplusplus
}
#endif

#endif
